#/bin/sh
#set -x

PROGS="vdrsync.pl \
      tcmplex \
      tcmplex-panteltje \
      mplex \
      submux \
      ppmtoy4m \
      mpeg2enc \
      transcode \
      dvdauthor \
      pnmfile \
      pnmtile \
      pnmtojpeg \
      jpeg2yuv \
      pnmtopng \
      pngtopnm \
      pnmcomp \
      arecord \
      mp2enc \
      gozer \
      mkisofs \
      dvdrecord \
      growisofs \
      requant \
      dvd+rw-mediainfo \
      dvd+rw-format \
      dvd+rw-booktype"

tput clear
echo "Voraussetzungen werden berprft"
echo "--------------------------------"
echo ""
for i in $PROGS
do
	type $i >/dev/null 2>&1
	status=$?
	[ $status -eq 0 ] && printf "%-20s \t\tOK.\n" $i || printf "%-20s\t\tFehlt\n" $i
done

echo ""
echo "Versionenliste (falls mglich)"
echo "-------------------------------"
echo ""

tcmplex -v
tcmplex-panteltje -v
mplex -v 2>&1|grep ersion
transcode -v
dvdauthor 2>&1|grep ersion
pnmfile -version 2>&1|grep ersion
pnmtile -version 2>&1|grep ersion
pnmtojpeg -version 2>&1|grep ersion
pnmtopng -version 2>&1|grep ersion
pnmtopng -version 2>&1|grep ersion
pnmcomp -version 2>&1|grep ersion
arecord --version
gozer -v
mkisofs --version
dvdrecord --version 2>&1|grep dvdrtools
growisofs --version


echo ""
echo "Libliste"
echo "--------"
echo ""

FILE=/tmp/libliste.$$
BINPROGS=`echo $PROGS|sed 's/vdrsync.pl//'`
for i in echo $BINPROGS
do
	ldd `which $i` >> $FILE
done
cat $FILE|awk '{print $1}'|sort -u 
[ -f $FILE ] && rm $FILE
