#!/bin/sh
# Version: 0.0.11 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdr2divx.sh,v 1.13 2003/09/27 15:23:03 dimi Exp $


if [ $# -ne 3 ]
then
    echo "Usage : $0 TempJobFile Jobfil Logfile"
    exit 1
fi

trap do_clean SIGINT SIGQUIT SIGTERM 
do_clean() {
	echo "Abbruch"
	exit
}

. ./vdrconvert.env

[ "$DEBUG" = "yes" ] && set -x || LOGFILE=/dev/null

# Default werte setzen
# Verzeichnisse / Dateinamen
[ -z "$DIVX_DESTDIR" ] 	 && DIVX_DESTDIR=$DESTDIR/divx
[ -z "$DIVXTYPE" ] 	 && DIVXTYPE=lavc
[ -z "$DIVX_SUFFIX" ] 	 && DIVX_SUFFIX=avi
# Optionen
[ -z "$DIVXCCHOPT" ] 	 && DIVXCCHOPT="-cache 32768" 
[ -z "$DIVXENCOPT" ] 	 && DIVXENCOPT="" # Sonstige optionen
[ -z "$DIVXTCMODE" ] 	 && DIVXTCMODE=s
[ -z "$DIVXVLAVCCODEC" ] && DIVXVLAVCCODEC=mpeg4
[ -z "$DIVXQUALITY" ] 	 && DIVXQUALITY=5
[ -z "$DIVXMP3R" ] 	 && DIVXMP3R=192
[ -z "$DIVXMP3_OPTS" ] 	 && DIVXMP3_OPTS="-b $DIVXMP3R -h"
[ -z "$DIVXSWS" ] 	 && DIVXSWS=2
[ -z "$DIVXCDLEN" ] 	 && DIVXCDLEN=750
[ -z "$DIVXMAXBITR" ] 	 && DIVXMAXBITR=2480 
[ -z "$DIVXMINBITR" ] 	 && DIVXMINBITR=0
[ -z "$DIVX_MAXLEN" ]    && DIVX_MAXLEN=90
[ -z "$DIVX_MAXDIV" ]    && DIVX_MAXDIV=25
[ -z "$DIVXUSESTREAMS" ] && DIVXUSESTREAMS="bd.ac3 c0.mpa"
# Schalter
[ -z "$DIVXFAKTOR" ]	 && DIVXFAKTOR=2
[ -z "$DIVXAUTOCROP" ]	 && DIVXAUTOCROP=no
[ -z "$DIVXSPLIT" ]	 && DIVXSPLIT=no
[ -z "$DIVX_RESDIV" ]	 && DIVX_RESDIV=no
# Check ob alle Programme ausfhrbar sind
# TODO

NewJobs=$1
JOBFIL=$2
TEMPDIR=${TEMPDIR}/${JOBFIL}

[ -d $DIVX_DESTDIR ] || mkdir -p $DIVX_DESTDIR
[ -d $TEMPDIR ] || mkdir -p $TEMPDIR
[ -z "$DIVX_TITLEDATE" ] && DIVX_TITLEDATE=$CONV_TITLEDATE

if [ -w ${TEMPDIR} -a -w ${DIVX_DESTDIR} ]
then
  let LINES=0
  LINES=`cat ${JOBFIL}|wc -l`
  if [ $LINES -gt 0 ]
  then
    cat ${JOBFIL}|grep '^$VDRROOT'|head -n $LINES ${JOBFIL}  > ${NewJobs}
  fi
  let NLLINES=`cat $JOBFIL|grep '^$VDRROOT'|nl|tail -n 1|awk '{ print $1 }'`
  let ALINES=`cat $JOBFIL|grep '^$VDRROOT'|wc -l`
  let ALINES=ALINES-1
  LastLine=`tail -n 1 < ${JOBFIL}`
  [ $ALINES -gt 0 ] && cat ${JOBFIL}|grep '^$VDRROOT'|tail -n $ALINES > ${JOBFIL} || > ${JOBFIL}
  [ $NLLINES -gt $ALINES ] && printf "%s" $LastLine >> ${JOBFIL}
  
  while [ `cat $NewJobs|wc -l` -gt 0 ]
  do
      CMDLIN=`head -n 1 $NewJobs`   # Job auslesen

      let Number=1
      echo "`date` : Start conversion for $CMDLIN" | tee -a ${JOBFIL}.done
      for i in $CMDLIN
      do
	[ "$DIVXSPLIT" = "no" ] && p=${i}/ || p=`echo $i/[0-9][0-9[0-9]*.vdr`
	for j in $p
	do
          printf "\t`date` : Begin conversion %s\n" "$j" | tee -a ${JOBFIL}.done
	  UniqueDir[Number]=`mktemp -d ${TEMPDIR}/VDRSYNC.XXXXXX`
	  status=$?
	  if [ $status -eq 0 ]
	  then
	      mkdir -p ${UniqueDir[Number]} 

	      r=`echo $VDRROOT|sed 's/\// /g'|wc -w`
	      spalten=`echo $i|sed 's/\// /g'|wc -w`
	      Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	      [ $[$r+2] -lt $[$spalten-1] ] && SubTitel=`echo $i|sed 's/\%//g'|cut -f $[$r+2]-$[$spalten-1] -d '/'` || SubTitel=""
	      Datum=`basename $i|cut -f1 -d'.'`
	      if [ -z "$SubTitel" ]
	      then
		  [ "$DIVX_TITLEDATE" = "yes" ] && Titel=${Datum}_${Record} ||Titel=${Record}
	      else
		  [ "$DIVX_TITLEDATE" = "yes" ] && Titel=${SubTitel}/${Datum}_${Record} || Titel=${SubTitel}/${Record}
	      fi
	      [ ! -d ${UniqueDir[Number]}/${SubTitel} ] && mkdir -p ${UniqueDir[Number]}/${SubTitel}
	      [ ! -d ${DIVX_DESTDIR}/${SubTitel} ] && mkdir -p ${DIVX_DESTDIR}/${SubTitel}
	      cd ${UniqueDir[Number]} # Temporaere Dateien sollen hier erstellt werden
	      LOG=${UniqueDir[Number]}/sync.log

              nice -n $PRIO $VDRSYNC -o ${UniqueDir[Number]} $j > $LOG 2>&1
	      status=$?
	      if [ $status -eq 0 ]
	      then
	        cat $LOG 
	        AC3OPT="-oac copy"
	        let ABITR=0
	        let field=0
	        for k in $DIVXUSESTREAMS
	        do
		    if [ -f ${UniqueDir[Number]}/$k ]
		    then
		      id=`echo $k|cut -f1 -d '.'`
		      ids=`echo $k|cut -f2 -d '.'`
		      [ "$ids" = "mpa" ] && ids=mp3
		      if [ $field -lt 2 ] 
		      then
		          MPLEXAUDIO=$MPLEXAUDIO`[ $field -eq 0 ] && echo "-p ${UniqueDir[Number]}/${id}.${ids} " || echo "-s ${UniqueDir[Number]}/${id}.${ids} "`
		      fi
		      if [ "${ids}" = "ac3" ] 
		      then
			AC3OPT="-aid 128 -oac copy" 
			let ABITR=ABITR+448
		      else
			echo "--mp2input $DIVXMP3_OPTS ${UniqueDir[Number]}/$k ${UniqueDir[Number]}/${id}.${ids}"|xargs nice -n ${PRIO} $LAME
			let ABITR=ABITR+DIVXMP3R
		      fi
		      break
		      let field=field+1
		    fi
	        done
	        nice -n ${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv $MPLEXAUDIO -m $DIVXTCMODE -o ${UniqueDir[Number]}/${Titel}.mpg 
	        # Bitrate berechnen
	        # Erst Laenge in MB ( nur Info )
                lmovie=`strings $LOG|grep "Mbytes of"|tail -n 1|awk '{print $1}'`
	        # Jetzt Laenge aus sec -> Minuten
                sec=`cat $LOG|grep "frames written for stream"|tail -n 1|cut -f2 -d '('|cut -f1 -d')'|awk '{print $1}'|cut -f1 -d'.'`
                min=$((sec/60))
	        [ $min -eq 0 ] && let min=1
                echo "File ${Titel} hat eine Lnge von $min Minuten bei $lmovie MB"
	        if [ "$DIVX_USEFAKTOR" != "no" ]
	        then
	          # Bitrate kann berechnet werden
	          [ $DIVXCDLEN -gt $((lmovie/DIVXFAKTOR)) ] && LEN=$((lmovie/DIVXFAKTOR)) || LEN=$DIVXCDLEN
	          [ $LEN -le 0 ] && LEN=1
	          VBITRT=$(((((LEN*1024*8/1000)*1024)-(ABITR*min*60))/(min*60)))
	          [ $DIVXMINBITR -gt 0 -a $VBITRT -le $DIVXMINBITR ] && VBITRT=$DIVXMINBITR 
	          echo "Berechnete Bitrate fr eine Lnge $LEN = $VBITRT"
	        else
		  # Bitrate ohne Faktor fr Brennen
		  VBITRT=$(((((DIVXCDLEN*1000)/min)/60)*8))
		  VBITRTN=$((VBITRT/DIVX_MAXLEN*min))
		  LEN=$((DIVXCDLEN*VBITRTN/VBITRT))
		  echo "MaxBitRate Film = $VBITRT"
		  echo "MaxBitRate CD mit $DIVX_MAXLEN min = $VBITRTN"
		  VBITRT_PROZ=$((VBITRT/100*$DIVX_MAXDIV))
		  VBITRT_MIN=$((VBITRT-VBITRT_PROZ))
		  VBITRT_MAX=$((VBITRT+VBITRT_PROZ))
                  echo "PROZ: $VBITRT_PROZ, min: $VBITRT_MIN, max: $VBITRT_MAX"
                  if [ $VBITRT_MAX -gt 0 -a $VBITRTN -le $VBITRT_MAX ]
                  then
                    VBITRT=$VBITRTN
                    echo "kleiner als CD"
                  else
		    if [ $VBITRT -gt 0 -a $VBITRTN -le $VBITRT ]
		    then
		      echo "$DIVX_MAXDIV% kleiner als CD -> Runde Bitrate auf"
		    else
		      if [ $VBITRT_MIN -gt 0 -a $VBITRTN -le $VBITRT_MIN ]
		      then
		        echo "$DIVX_MAXDIV% groesser als CD -> Runde Bitrate ab"
		      else
		        VBITRT=$((((((DIVXCDLEN*1000*2)/min)/60)*8)-200))
		        echo "mehr als $DIVX_MAXDIV% groesser als CD, passe VBitrate/Filelnge fr 2 CDs an"
		      fi
		    fi
		  fi
		  if [ $VBITRT_MIN -gt 0 -a $VBITRTN -le $VBITRT_MIN ]
		  then
	            LEN=$((LEN*2))
		    echo "Berechnete Bitrate fr eine Lnge $LEN = $VBITRT"
		    VBITRT=$((VBITRT-ABITR))
	            echo "Berechnete VideoBitrate fr eine Lnge $LEN = $VBITRT"
	            LEN=$((LEN/2))
		  else
	            echo "Berechnete Bitrate fr eine Lnge $LEN = $VBITRT"
		    VBITRT=$((VBITRT-ABITR))
	            echo "Berechnete VideoBitrate fr eine Lnge $LEN = $VBITRT"
		  fi


	          if [ $DIVXMINBITR -gt 0 -a $VBITRT -le $DIVXMINBITR ]
		  then
		      echo "ERROR : Berechnete bitrate kleiner als Minimal festgelegte $DIVXMINBITRim environment"
	  	      cd -
          	      rm -rf ${UniqueDir[Number]}
		      exit 1
		  fi
	        fi

	        ASPECT=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $5}'`
	        if [ "$ASPECT" = "3" ] 
	        then
    	          X=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f1 -d'x'`
    	          Y=$(($X*9/16))
    	          ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
	          DIVXCROP=""
		  let step=0
		  let crop_ok=0
                  if [ "$DIVXAUTOCROP" = "yes" ]
	          then
		      for k in 00:05:00 00:10:00 00:15:00 00:20:00 00:25:00 00:30:00 00:35:00 00:40:00 00:45:00 01:00:00 01:15:00 01:30:00
		      do
		        DIVXCROP[step]=""
                        nice -n ${PRIO} $MENCODER -ss $k -frames 100 $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
		          -vop cropdetect \
                          -mc 0 \
                          -vc mpeg12 \
                          -ovc lavc \
                          -lavcopts vcodec=$DIVXVLAVCCODEC:vhq:ildct:vqmin=2:vbitrate=$VBITRT \
                          -o /dev/null \
                          ${UniqueDir[Number]}/${Titel}.mpg > ${UniqueDir[Number]}/crop.log
			status=$?
			if [ $status -eq 0 ]
			then
		          DIVXCROP[step]=`cat ${UniqueDir[Number]}/crop.log|grep crop= |tail -n 1 | cut -f3 -d '('|sed 's/)//'|sed 's/-vop //'`
			  [ ! -z "${DIVXCROP[step]}" ] && let step=step+1
			fi
		      done
		      if [ $step -ge 2 ]
		      then
	                  until [ $step -eq 1 -o $crop_ok -eq 3 ] 
		          do
		      	      let crop_ok=0
		      	      let ustep=step
	                      until [ $ustep -eq 1 -o $crop_ok -eq 3 ] 
		              do
			  	if [ ! -z "${DIVXCROP[ustep]}" -a "${DIVXCROP[ustep]}" = "${DIVXCROP[ustep-1]}" ] 
				then
				   let crop_ok=crop_ok+1
				fi
				let ustep=ustep-1
		              done
			      let step=step-1
		          done
		      fi
		      if [ $crop_ok -eq 3 ]
		      then
		          CROPMIN=`echo ${DIVXCROP[step]}|cut -f 4 -d ':'`
			  echo "CROP : $crop_ok Treffer gefunden."
		          Y=$(($Y-$CROPMIN))
    	                  ASPOPT="-vop scale=$X:$Y,$DIVXCROP,lavcdeint -sws $DIVXSWS"
		      fi
		  else
		      if [ "$DIVX_RESDIV" = "yes" ]
		      then
	                  #X=$((X/2))
    	          	  #Y=$(($X*9/16))
    	                  ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
		      fi
	          fi
	        else
    	          #X=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f1 -d'x'`
		  #[ "$DIVX_RESDIV" = "yes" ] && X=$((X/2))
    	          #Y=$(($X*3/4))
    	          Y=`$MENCODER -frames 0 ${UniqueDir[Number]}/${Titel}.mpg 2>/dev/null|grep aspect|cut -f1 -d ')'|awk '{print $3}'|cut -f2 -d'x'`
		  [ "$DIVX_RESDIV" = "yes" ] && Y=$((Y/2))
    	          X=$(($Y*4/3))
    	          ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
	        fi
   	 
	        for t in $DIVXTYPE
	        do
		  case $t in
		      lavc)
		          echo "Erstelle $t Format 2 Pass"
	                  for pass in 1 2 
	                  do
    	 	            nice -n ${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
		 	      -mc 0 \
		 	      -vc mpeg12 \
		 	      -passlogfile ${UniqueDir[Number]}/divx2pass.log \
		 	      -ovc lavc \
		 	      -lavcopts vcodec=$DIVXVLAVCCODEC:vhq:ildct:vpass=$pass:vqmin=2:vbitrate=$VBITRT \
		 	      -o ${UniqueDir[Number]}/output.avi \
		 	      ${UniqueDir[Number]}/${Titel}.mpg 
    
	   		    status=$?
		          done
		          ;;
		      divx)
		          echo "Erstelle  $t Format 2 Pass"
	                  for pass in 1 2 
	                  do
                            nice -n ${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                              -mc 0 \
                              -vc mpeg12 \
                              -passlogfile ${UniqueDir[Number]}/divx2pass.log \
                              -ovc divx4 \
                              -divx4opts pass=$pass:q=$DIVXQUALITY:br=$VBITRT \
                              -o ${UniqueDir[Number]}/output.avi \
                              ${UniqueDir[Number]}/${Titel}.mpg
    
	   		    status=$?
		          done
                           ;;
		      xvid)
		          echo "Erstelle  $t Format sincle Pass"
                          nice -n ${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                              -mc 0 \
                              -vc mpeg12 \
                              -ovc xvid \
                              -xvidopts dr2 \
                              -o ${UniqueDir[Number]}/output.avi \
                              ${UniqueDir[Number]}/${Titel}.mpg
    
	   	          status=$?
                          ;;
		      divxlowq)
		          echo "Erstelle  $t Format sincle Pass"
		          VBITRT=400
	                  X=$((X/2))
	                  Y=$((Y/2))
    	                  ASPOPT="-vop scale=$X:$Y,lavcdeint -sws $DIVXSWS"
                          echo "Erstelle DivX LQ Format (q=1, bitr=400) sincle Pass"
	                  nice -n ${PRIO} $MENCODER $DIVXENCOPT $AC3OPT $DIVXCCHOPT $ASPOPT \
                              -mc 0 \
                              -vc mpeg12 \
                              -o ${UniqueDir[Number]}/output.avi \
                              -ovc divx4 \
                              -divx4opts q=1:br=400 \
                              ${UniqueDir[Number]}/${Titel}.mpg 
         
	                  status=$?
        	        ;;
    		      *)
        	           echo "Encodertype $t wird nicht untersttzt."
		           status=2001
        	        ;;
		  esac
	          if [ $status -ne 0 ]
	          then
	             echo "Bei der Konvertierung von ${Titel} ist es zu Fehlern gekommen.status=<${status}>"
	          else
		     if [ "$DIVX_EXPANDFILENAME" = "yes" ]
		     then
		         if [ ! -f ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}.${DIVX_SUFFIX} ]
		         then
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}.${DIVX_SUFFIX}
		         else
		             let index=1
		             until [ ! -f ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}_-$index.${DIVX_SUFFIX} ]
		             do
			         let index=index+1
		             done
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}_-$index.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}_${t}_${VBITRT}_-$index.${DIVX_SUFFIX}
		         fi
		     else
		         if [ ! -f ${DIVX_DESTDIR}/${Titel}.${DIVX_SUFFIX} ]
		         then
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}.${DIVX_SUFFIX}
		         else
		             let index=1
		             until [ ! -f ${DIVX_DESTDIR}/${Titel}-$index.${DIVX_SUFFIX} ]
		             do
			         let index=index+1
		             done
		             mv ${UniqueDir[Number]}/output.avi ${DIVX_DESTDIR}/${Titel}-$index.${DIVX_SUFFIX}
		             status=$?
			     File=${DIVX_DESTDIR}/${Titel}-$index.${DIVX_SUFFIX}
		         fi
		     fi
		     touch -r $j $File
		     if [ "$DIVX_AUTOWRITE" = "yes" ]
		     then
			cd -
			echo "$File:CD:DEL" >> burn
			cd -
		     fi
	          fi
	       done
    	    fi
    	  fi
	  # Temp Files lschen
	  cd -
          rm -rf ${UniqueDir[Number]}
	  let Number=Number+1
          printf "\t`date` : Finish %s\n" "$i" | tee -a ${JOBFIL}.done
	done
      done
      echo "`date` : Parts from $CMDLIN completed" | tee -a ${JOBFIL}.done
      cp $NewJobs $NewJobs.$$
      grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs 
      rm $NewJobs.$$
  done
  rm $NewJobs
else
    echo "Bitte die Schreibechte fr ${TEMPDIR} und ${DIVX_DESTDIR} berprfen. Keine verarbeitung mglich"
fi

