#!/bin/sh
# Version: 0.0.11 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdr2mp3.sh,v 1.11 2003/09/28 11:36:25 dimi Exp $

if [ $# -ne 3 ]
then
    echo "Usage : $0 TempJobFile Jobfil Logfile"
    exit 1
fi
. ./vdrconvert.env

[ "$DEBUG" = "yes" ] && set -x || LOGFILE=/dev/null

# Default Options
[ -z "$MP3_DESTDIR" ]  && MP3_DESTDIR=$DESTDIR/mp3 
[ -z "$MP3_BITRATE" ]  && MP3_BITRATE=192
[ -z "$MP3_OPTS" ]     && MP3_OPTS="-b $MP3_BITRATE -h --resample 44100"
[ -z "$MP3_SPLIT" ]    && MP3_SPLIT="no"
[ -z "$MPLAYERMP3SOURCE" ]    && MPLAYERMP3SOURCE=""
[ -z "$MP3_TITLEDATE" ] && MP3_TITLEDATE=$CONV_TITLEDATE

NewJobs=$1
JOBFIL=$2
TEMPDIR=${TEMPDIR}/${JOBFIL}

[ -d $MP3_DESTDIR ] || mkdir -p $MP3_DESTDIR 
[ -d $TEMPDIR ] || mkdir -p $TEMPDIR

if [ -w ${TEMPDIR} -a -w ${MP3_DESTDIR} ]
then
  let LINES=0
  LINES=`cat ${JOBFIL}|wc -l`
  if [ $LINES -gt 0 ]
  then
    cat ${JOBFIL}|head -n $LINES ${JOBFIL} | grep '^/' > ${NewJobs}
  fi
#  [ "`cat $JOBFIL||head -n $LINES $JOBFIL|tail -n 1`" != "`tail -n 1 $JOBFIL`" ] && printf "%s " `tail -n 1 $JOBFIL` > $JOBFIL || < /dev/null > $JOBFIL
  [ `nl $JOBFIL |tail -n 1|awk '{ print $1 }'` -ne `wc -l $JOBFIL|awk '{ print $1 }'` ] && printf "%s " `tail -n 1 $JOBFIL` > $JOBFIL || < /dev/null > $JOBFIL
  while [ `cat $NewJobs|wc -l` -gt 0 ]
  do
      CMDLIN=`head -n 1 $NewJobs`   # Job auslesen
      let Number=1
      echo "`date` : Start conversion for $CMDLIN" | tee -a ${JOBFIL}.done
      for i in $CMDLIN
      do
          printf "\t`date` : Begin conversion %s\n" "$i" | tee -a ${JOBFIL}.done
	  r=`echo $VDRROOT|sed 's/\// /g'|wc -w`
	  spalten=`echo $i|sed 's/\// /g'|wc -w`
	  Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	  [ $[$r+2] -lt $[$spalten-1] ] && SubTitel=`echo $i|sed 's/\%//g'|cut -f $[$r+2]-$[$spalten-1] -d '/'` || SubTitel=""
	  Datum=`basename $i|cut -f1 -d'.'`
	  if [ -z "$SubTitel" ]
	  then
		[ "$MP3_TITLEDATE" = "yes" ] && Titel=${Datum}_${Record} ||Titel=${Record}
	  else
		[ "$MP3_TITLEDATE" = "yes" ] && Titel=${SubTitel}/${Datum}_${Record} || Titel=${SubTitel}/${Record}
	  fi
	  [ ! -d ${MP3_DESTDIR}/`dirname ${Titel}` ] && mkdir -p ${MP3_DESTDIR}/`dirname ${Titel}`
	  if [ "$MP3_SPLIT" = "no" ]
	  then
	      UniqueDir[Number]=`mktemp -d ${TEMPDIR}/VDRSYNC.XXXXXX`
	      mkdir -p ${UniqueDir[Number]}/${Titel}
	      cd ${UniqueDir[Number]}
              nice -n $PRIO $VDRSYNC -audio-only -o ${UniqueDir[Number]} $i/ 
	      # Mit Lame zu mp3
	      #nice -n ${PRIO} $LAME --mp2input $MP3_OPTS ${UniqueDir[Number]}/c0.mpa ${UniqueDir[Number]}/${Titel}.mp3
	      nice -n $PRIO mpg123 -s -w out.$$.wav ${UniqueDir[Number]}/c0.mpa
	      status=$?
	      if [ $status -eq 0 ]
	      then
	        nice -n $PRIO $LAME $MP3_OPTS out.$$.wav ${UniqueDir[Number]}/${Titel}.mp3
	        status=$?
	        rm -f out.$$.wav
	        if [ $status -eq 0 ]
	        then
	            if [ ! -f ${MP3_DESTDIR}/${Titel}.mp3 ]
		    then
		             cp ${UniqueDir[Number]}/${Titel}.mp3 ${MP3_DESTDIR}/${Titel}.mp3
			     File=${MP3_DESTDIR}/${Titel}.mp3
	            else
		            let index=1
		            until [ ! -f ${MP3_DESTDIR}/${Titel}-$index.mp3 ]
		            do
			        let index=index+1
		            done
		            cp ${UniqueDir[Number]}/${Titel}.mp3 ${MP3_DESTDIR}/${Titel}-$index.mp3
			    File=${MP3_DESTDIR}/${Titel}-$index.mp3
	            fi
	        else
		    echo "ERROR : Fehler bei $LAME rc = $status"
	        fi
	      else
		echo "ERROR : Fehler bei mpg123 rc = $status"
	      fi
	      cd -
              rm -rf ${UniqueDir[Number]}
	      let Number=Number+1
              printf "\t`date` : Finish %s\n" "$i" | tee -a ${JOBFIL}.done
	  else
	      # Einzelne files bearbeiten
	      [ ! -z "$MPLAYERMP3SOURCE" ] && M3U=${MPLAYERMP3SOURCE}/`basename ${Titel}`.m3u || M3U=""
	      let SNumber=0
	      for part in $i/[0-9][0-9][0-9]*.vdr
	      do
	          UniqueDir[Number]=`mktemp -d ${TEMPDIR}/VDRSYNC.XXXXXX`
	          mkdir -p ${UniqueDir[Number]}/${Titel}
	          cd ${UniqueDir[Number]}
                  nice -n $PRIO $VDRSYNC -audio-only -o ${UniqueDir[Number]} $part 
	          # Mit Lame zu mp3
	          #nice -n ${PRIO} $LAME --mp2input $MP3_OPTS ${UniqueDir[Number]}/c0.mpa ${UniqueDir[Number]}/${Titel}.mp3
	          nice -n $PRIO mpg123 -s -w out.$$.wav ${UniqueDir[Number]}/c0.mpa
		  status=$?
		  if [ $status -eq 0 ]
		  then
	            nice -n $PRIO $LAME $MP3_OPTS out.$$.wav ${UniqueDir[Number]}/${Titel}.mp3
		    status=$?
		    rm out.$$.wav
		    if [ $status -eq 0 ]
		    then
		        let SNumber=SNumber+1
		        let index=1
		        until [ ! -f ${MP3_DESTDIR}/${Titel}_${Number}-$index.mp3 ]
		        do
			   let index=index+1
		        done
		        cp ${UniqueDir[Number]}/${Titel}.mp3 ${MP3_DESTDIR}/${Titel}_${Number}-$index.mp3
			File=${MP3_DESTDIR}/${Titel}_${Number}-$index.mp3
		        [ ! -z "$M3U" ] && echo "$File"|cut -f3- -d '/' >> $M3U
		    else
		        echo "ERROR : Fehler bei $LAME  rc = $status"
		    fi
		  else
		        echo "ERROR : Fehler bei mpg123 rc = $status"
		  fi
	          cd -
	          if [ "$MP3_AUTOWRITE" = "yes" ]
                  then
		        echo "$File:CD:DEL" >> burn
	          fi
                  rm -rf ${UniqueDir[Number]}
	          let Number=Number+1
	      done
              printf "\t`date` : Finish %s with splitting\n" "$i" | tee -a ${JOBFIL}.done
	  fi
      done
      # Cleaning
      echo "`date` : Parts from $CMDLIN completed" | tee -a ${JOBFIL}.done
      cp $NewJobs $NewJobs.$$
      grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs 
      rm $NewJobs.$$
  done
  rm $NewJobs
else
      echo "ERROR : ${MP3_DESTDIR} or ${TEMPDIR} are not writable. $0 exit"
fi
