#!/bin/sh
# Version: 0.0.11 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdr2mpg.sh,v 1.9 2003/09/27 15:29:57 dimi Exp $

if [ $# -ne 3 ]
then
    echo "Usage : $0 TempJobFile Jobfil Logfile"
    exit 1
fi
. ./vdrconvert.env


[ -z "$MPG_DESTDIR" ]   && MPG_DESTDIR=$DESTDIR/mpg 
[ -z "$MPG_TITLEDATE" ] && MPG_TITLEDATE=$CONV_TITLEDATE

NewJobs=$1
JOBFIL=$2
TEMPDIR=${TEMPDIR}/${JOBFIL}

[ -d $MPG_DESTDIR ] || mkdir -p $MPG_DESTDIR 
[ -d $TEMPDIR ] || mkdir -p $TEMPDIR

if [ -w ${TEMPDIR} -a -w ${MPG_DESTDIR} ]
then
  let LINES=0
  LINES=`cat ${JOBFIL}|wc -l`
  if [ $LINES -gt 0 ]
  then
    cat ${JOBFIL}|head -n $LINES ${JOBFIL} | grep '^/' > ${NewJobs}
  fi
#  [ "`head -n $LINES $JOBFIL|tail -n 1`" != "`tail -n 1 $JOBFIL`" ] && printf "%s " `tail -n 1 $JOBFIL` > $JOBFIL || < /dev/null > $JOBFIL
  [ `nl $JOBFIL |tail -n 1|awk '{ print $1 }'` -ne `wc -l $JOBFIL|awk '{ print $1 }'` ] && printf "%s " `tail -n 1 $JOBFIL` > $JOBFIL || < /dev/null > $JOBFIL
  while [ `cat $NewJobs|wc -l` -gt 0 ]
  do
      CMDLIN=`head -n 1 $NewJobs`   # Job auslesen
      let Number=1
      echo "`date` : Start conversion for $CMDLIN" | tee -a ${JOBFIL}.done
      for i in $CMDLIN
      do
          printf "\t`date` : Begin conversion %s\n" "$i" | tee -a ${JOBFIL}.done
	  UniqueDir[Number]=`mktemp -d ${TEMPDIR}/VDRSYNC.XXXXXX`
	  r=`echo $VDRROOT|sed 's/\// /g'|wc -w`
	  spalten=`echo $i|sed 's/\// /g'|wc -w`
	  Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	  [ $[$r+2] -lt $[$spalten-1] ] && SubTitel=`echo $i|sed 's/\%//g'|cut -f $[$r+2]-$[$spalten-1] -d '/'` || SubTitel=""
	  Datum=`basename $i|cut -f1 -d'.'`
	  if [ -z "$SubTitel" ]
	  then
		[ "$MPG_TITLEDATE" = "yes" ] && Titel=${Datum}_${Record} ||Titel=${Record}
	  else
		[ "$MPG_TITLEDATE" = "yes" ] && Titel=${SubTitel}/${Datum}_${Record} || Titel=${SubTitel}/${Record}
	  fi
	  [ ! -d ${UniqueDir[Number]}/${SubTitel} ] && mkdir -p ${UniqueDir[Number]}/${SubTitel}
	  [ ! -d ${MPG_DESTDIR}/${SubTitel} ] && mkdir -p ${MPG_DESTDIR}/${SubTitel}
	  mkdir -p ${UniqueDir[Number]}
	  cd ${UniqueDir[Number]}
          nice -n $PRIO $VDRSYNC -o ${UniqueDir[Number]} $i/
          #echo -o ${UniqueDir[Number]} $i/ | xargs nice -n $PRIO $VDRSYNC 			  # und encoding starten ...      
	  if [ -f ${UniqueDir[Number]}/bd.ac3 ] # Das geht bestimmt besser
	  then 
	    nice -n ${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mpa -s${UniqueDir[Number]}/bd.ac3 -m d -o ${MPG_DESTDIR}/${Titel}.mpg # mpg in tempdir erzeugen und erst am schluss lschen
	  else
	    nice -n ${PRIO} $TCMPLEX -i ${UniqueDir[Number]}/*.mpv -p ${UniqueDir[Number]}/c0.mpa -m d -o ${MPG_DESTDIR}/${Titel}.mpg
	  fi
	  cd -
	  if [ "$MPG_AUTOWRITE" = "yes" ]
          then
		echo "${MPG_DESTDIR}/${Titel}.mpg:CD:DEL" >> burn
	  fi
          rm -rf ${UniqueDir[Number]}
	  let Number=Number+1
          printf "\t`date` : Finish %s\n" "$i" | tee -a ${JOBFIL}.done
      done
      echo "`date` : Parts from $CMDLIN completed" | tee -a ${JOBFIL}.done
      cp $NewJobs $NewJobs.$$
      grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs 
      rm $NewJobs.$$
  done
  rm $NewJobs
else
      echo "ERROR : ${MPG_DESTDIR} or ${TEMPDIR} are not writable. $0 exit"
fi
