#!/bin/sh
# Version: 0.0.11 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdr2vcd.sh,v 1.10 2003/09/27 15:32:44 dimi Exp $

if [ $# -ne 3 ]
then
    echo "Usage : $0 TempJobFile Jobfil Logfile"
    exit 1
fi
. ./vdrconvert.env


[ -z "$VCD_DESTDIR" ]   && VCD_DESTDIR=$DESTDIR/vcd 
[ -z "$VCD_TITLEDATE" ] && VCD_TITLEDATE=$CONV_TITLEDATE

NewJobs=$1
JOBFIL=$2
TEMPDIR=${TEMPDIR}/${JOBFIL}

[ -d $VCD_DESTDIR ] || mkdir -p $VCD_DESTDIR 
[ -d $TEMPDIR ] || mkdir -p $TEMPDIR

if [ -w ${TEMPDIR} -a -w ${VCD_DESTDIR} ]
then
  let LINES=0
  LINES=`cat ${JOBFIL}|wc -l`
  if [ $LINES -gt 0 ]
  then
    cat ${JOBFIL}|head -n $LINES ${JOBFIL} | grep '^/' > ${NewJobs}
  fi
#  [ "`head -n $LINES $JOBFIL|tail -n 1`" != "`tail -n 1 $JOBFIL`" ] && printf "%s " `tail -n 1 $JOBFIL` > $JOBFIL || < /dev/null > $JOBFIL
  [ `nl $JOBFIL |tail -n 1|awk '{ print $1 }'` -ne `wc -l $JOBFIL|awk '{ print $1 }'` ] && printf "%s " `tail -n 1 $JOBFIL` > $JOBFIL || < /dev/null > $JOBFIL
  while [ `cat $NewJobs|wc -l` -gt 0 ]
  do
      CMDLIN=`head -n 1 $NewJobs`   # Job auslesen
      let Number=1
      echo "`date` : Start conversion for $CMDLIN" | tee -a ${JOBFIL}.done
      for i in $CMDLIN
      do
          printf "\t`date` : Begin conversion %s\n" "$i" | tee -a ${JOBFIL}.done
	  UniqueDir[Number]=`mktemp -d ${TEMPDIR}/VCD.XXXXXX`
	  mkdir -p ${UniqueDir[Number]}
	  cd ${UniqueDir[Number]}
	  r=`echo $VDRROOT|sed 's/\// /g'|wc -w`
	  spalten=`echo $i|sed 's/\// /g'|wc -w`
	  Record=`echo $i|sed 's/\%//g'|cut -f $spalten -d '/'`
	  [ $[$r+2] -lt $[$spalten-1] ] && SubTitel=`echo $i|sed 's/\%//g'|cut -f $[$r+2]-$[$spalten-1] -d '/'` || SubTitel=""
	  Datum=`basename $i|cut -f1 -d'.'`
	  if [ -z "$SubTitel" ]
	  then
		[ "$VCD_TITLEDATE" = "yes" ] && Titel=${Datum}_${Record} ||Titel=${Record}
	  else
		[ "$VCD_TITLEDATE" = "yes" ] && Titel=${SubTitel}/${Datum}_${Record} || Titel=${SubTitel}/${Record}
	  fi
	  [ ! -d ${UniqueDir[Number]}/${Titel} ] && mkdir -p ${UniqueDir[Number]}/${Titel}
	  [ ! -d ${VCD_DESTDIR}/${Titel} ] && mkdir -p ${VCD_DESTDIR}/${Titel}
          nice -n $PRIO $TOSVCD ${VCD_OPTS} -1 -o ${UniqueDir[Number]}/${Titel} $i
	  mv ${UniqueDir[Number]}/${Titel}*.bin ${VCD_DESTDIR}/${Titel}
	  mv ${UniqueDir[Number]}/${Titel}*.cue ${VCD_DESTDIR}/${Titel}
	  cd -
	  if [ "$VCD_AUTOWRITE" = "yes" ] 
	  then
	    for burnfile in ${VCD_DESTDIR}/${Titel}/*.cue
	    do
	       echo "$burnfile:CUE:DEL" >> burn
	    done	
	  fi
     	  rm -rf ${UniqueDir[Number]}
          printf "\t`date` : Finish %s\n" "$i" | tee -a ${JOBFIL}.done
     done
     echo "`date` : Parts from $CMDLIN completed" | tee -a ${JOBFIL}.done
     cp $NewJobs $NewJobs.$$
     grep -x -v "$CMDLIN" $NewJobs.$$ > $NewJobs 
     rm $NewJobs.$$
  done
  rm $NewJobs
else
      echo "ERROR : ${VCD_DESTDIR} or ${TEMPDIR} are not writable. $0 exit"
fi
