#!/bin/sh
# Version: 0.0.11 pre-alpha
# Author: Dimitrios Dimitrakos mail@dimitrios.de
# $Id: vdrconvert.sh,v 1.11 2003/09/28 11:35:43 dimi Exp $
# For the environment
LANG=en_US
. ./vdrconvert.env

set -x

# Default values for executables
[ -z "$VDRROOT" ]    && export VDRROOT=/video
[ -z "$DESTDIR" ]    && export DESTDIR=/video
[ -z "$VDRSYNC" ]    && export VDRSYNC=vdrsync.pl
[ -z "$TCMPLEX" ]    && export TCMPLEX=tcmplex
[ -z "$DVBMPLEX" ]   && export DVBMPLEX=dvb-mplex
[ -z "$MPLEX" ]      && export MPLEX=mplex
[ -z "$TCMPLEX_PANTELTJE" ] && export TCMPLEX_PANTELTJE=tcmplex-panteltje
[ -z "$MKISOFS" ]    && export MKISOFS=mkisofs
[ -z "$MENCODER" ]   && export MENCODER=mencoder
[ -z "$LAME" ]       && export LAME=lame
[ -z "$DVDAUTHOR" ]  && export DVDAUTHOR=dvdauthor
[ -z "$TOSVCD" ]     && export TOSVCD=tosvcd
[ -z "$COMPRESS" ]   && export COMPRESS=bzip2
# Nice level
[ -z "$PRIO" ]       && export PRIO=15
[ -z "$SLEEP_TIME" ] && export SLEEP_TIME=5
# Default Directorys
[ -z "$TEMPDIR" ]    && export TEMPDIR=$DESTDIR/tmp
[ -z "$LOGDIR" ]     && export LOGDIR=/tmp
# VDR Messages
[ -z "$SVDRPSEND" ]  && export SVDRPSEND=svdrpsend.pl
# Schalter
[ -z "$PARQ" ]       && export PARQ="none"
[ -z "$CONV_TITLEDATE" ] && CONV_TITLEDATE=no


while true; do	

 [ -d $TEMPDIR ] || mkdir -p $TEMPDIR
 [ -d $LOGDIR ] || mkdir -p $LOGDIR
 if [ -w ${TEMPDIR} -a -w ${LOGDIR} ]
 then
  for JOBFIL in $CONVERT_JOBS
  do
    if [ ! -f $JOBFIL ]
    then 
	echo $JOBFIL not found ! Creating empty one !!!
	touch $JOBFIL
    fi

    if [ ! -f ${JOBFIL}.done ]
    then 
	echo ${JOBFIL}.done not found ! Creating empty one !!!
	touch ${JOBFIL}.done
    fi

    let LINES=0
    LINES=`cat $JOBFIL | wc -l`  
    
    let run=0
    if [ "$PARQ" = "no" ]
    then
	run=`ps -aef|grep ${JOBFIL}.sh|grep -v grep|wc -l`
    fi
    if [ "$PARQ" = "none" ]
    then
        for r in $CONVERT_JOBS
	do
	    if [ $run -eq 0 ]
	    then
		run=`ps -aef|grep ${r}.sh|grep -v grep|wc -l`
	    fi
	done
    fi

    if [ $LINES -gt 0 -a $run -eq 0 ]
    then
    	  echo "Job fir $0 gefunden : $CONVERT_JOBS"
    	  echo
          NewJobs=`mktemp ${TEMPDIR}/${JOBFIL}.XXXXXX`
	  status=$?
	  if [ $status -eq 0 ]
	  then
    	      # Define Logfile
    	      [ "$DEBUG" != "yes" ] && CONVERTLOG=/dev/null || CONVERTLOG=${LOGDIR}/${JOBFIL}.log

	      echo "Start ${JOBFIL}.sh $NewJobs $JOBFIL Log = $CONVERTLOG"
	      ./${JOBFIL}.sh $NewJobs $JOBFIL  $CONVERTLOG 2>&1 |tee -a $CONVERTLOG &
      	      logger "./${JOBFIL}.sh $NewJobs $JOBFIL  $CONVERTLOG 2>&1 >> $CONVERTLOG gestartet"
	  fi
    fi
  done
  sleep $SLEEP_TIME
 else
      echo "ERROR : ${TEMPDIR} or ${LOGDIR} are not writable. $0 exit"
      logger "ERROR : ${TEMPDIR} or ${LOGDIR} are not writable. $0 exit"
 fi
done

